package javax.activation;

import java.util.WeakHashMap;
import java.io.File;
import java.util.Map;

public abstract class FileTypeMap
{
    private static FileTypeMap defaultMap;
    private static Map<ClassLoader, FileTypeMap> map;
    
    public FileTypeMap() {
    }
    
    public abstract String getContentType(File p0);
    
    public abstract String getContentType(String p0);
    
    public static synchronized void setDefaultFileTypeMap(FileTypeMap fileTypeMap) {
        SecurityManager security = System.getSecurityManager();
        if (security != null) {
            try {
                security.checkSetFactory();
            }
            catch (SecurityException ex) {
                if (FileTypeMap.class.getClassLoader() == null || FileTypeMap.class.getClassLoader() != fileTypeMap.getClass().getClassLoader()) {
                    throw ex;
                }
            }
        }
        FileTypeMap.map.remove(SecuritySupport.getContextClassLoader());
        FileTypeMap.defaultMap = fileTypeMap;
    }
    
    public static synchronized FileTypeMap getDefaultFileTypeMap() {
        if (FileTypeMap.defaultMap != null) {
            return FileTypeMap.defaultMap;
        }
        ClassLoader tccl = SecuritySupport.getContextClassLoader();
        FileTypeMap def = (FileTypeMap)FileTypeMap.map.get(tccl);
        if (def == null) {
            def = new MimetypesFileTypeMap();
            FileTypeMap.map.put(tccl, def);
            return def;
        }
        return def;
    }
    
    static {
        FileTypeMap.defaultMap = null;
        FileTypeMap.map = new WeakHashMap();
    }
}
